const win = Ti.UI.createWindow({
	exitOnClose: true,
	layout: 'vertical'
});

const crypto = require('ti.crypto');

const randomBytes = function(length) {
	const buffer = Ti.createBuffer({length});
	for (let i = 0; i < length; i++) {
		buffer[i] = Math.floor(Math.random() * 256);
	}
	return buffer;
}

const key = Ti.createBuffer({value: '1234567890123456'});
const initializationVector = randomBytes(16);

const cryptor = crypto.createCryptor({
	algorithm: crypto.ALGORITHM_AES128,
	key,
	initializationVector
});

const encrypted_data_buffer = Ti.createBuffer({value: 'Hello World!'});
const num_bytes_encrypted = cryptor.encrypt(encrypted_data_buffer);
console.log('encrypted bytes:', num_bytes_encrypted, encrypted_data_buffer.toString());

const encrypted_data_label = Ti.UI.createLabel({
	text: encrypted_data_buffer.toString(),
	top: 50,
	left: 10,
	height: 40
});

const decrypted_data_buffer = encrypted_data_buffer.clone();
const num_bytes_decrypted = cryptor.decrypt(decrypted_data_buffer);
console.log('decrypted bytes:', num_bytes_decrypted, decrypted_data_buffer.toString());

const decrypted_data_label = Ti.UI.createLabel({
	text: decrypted_data_buffer.toString(),
	top: 100,
	left: 10,
	height: 40
});

win.add([encrypted_data_label, decrypted_data_label]);
win.open();
